//+------------------------------------------------------------------+
//|   #FX500 day-week-high-low.mq4, created by Henk van Hirtum
//+------------------------------------------------------------------+
#property  indicator_chart_window

extern string note1 = "Colors";
extern color YesterdayHighLowColor = RoyalBlue;
extern color LastWeekHighLowColor = RoyalBlue;

double HiPrice, LoPrice, HiPriceWeek, LoPriceWeek;
datetime StartTime, StartTimeWeek;

int init() {
  return (0);
}

int deinit() {
  ObjectDelete("dayrange");
  ObjectDelete("weekrange");
  return (0);
}

//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+
int DrawFibo() {
  if(ObjectFind("dayrange") == -1) {
    ObjectCreate("dayrange",OBJ_FIBO, 0, StartTime, HiPrice, StartTime, LoPrice);
  } else {
    ObjectSet("dayrange",OBJPROP_TIME2, StartTime);
    ObjectSet("dayrange",OBJPROP_TIME1, StartTime);
    ObjectSet("dayrange",OBJPROP_PRICE1, HiPrice);
    ObjectSet("dayrange",OBJPROP_PRICE2, LoPrice);
  }
  ObjectSet("dayrange",OBJPROP_LEVELCOLOR, YesterdayHighLowColor);
  ObjectSet("dayrange",OBJPROP_FIBOLEVELS, 2);
  ObjectSet("dayrange",OBJPROP_FIRSTLEVEL+0, 0.0);
  ObjectSetFiboDescription("dayrange", 0, "Yesterday Low");
  ObjectSet("dayrange",OBJPROP_FIRSTLEVEL+1, 1.0);
  ObjectSetFiboDescription("dayrange", 1, "Yesterday High");
  ObjectSet("dayrange", OBJPROP_RAY, true);
  ObjectSet("dayrange", OBJPROP_BACK, true);
   
  ObjectSet("dayrange", OBJPROP_COLOR, Black);
   
  if(ObjectFind("weekrange") == -1) {
    ObjectCreate("weekrange",OBJ_FIBO, 0 ,StartTimeWeek,HiPriceWeek,StartTimeWeek,LoPriceWeek);
  } else {
    ObjectSet("weekrange", OBJPROP_TIME2, StartTimeWeek);
    ObjectSet("weekrange", OBJPROP_TIME1, StartTimeWeek);
    ObjectSet("weekrange", OBJPROP_PRICE1, HiPriceWeek);
    ObjectSet("weekrange", OBJPROP_PRICE2, LoPriceWeek);
  }
  ObjectSet("weekrange", OBJPROP_LEVELCOLOR, LastWeekHighLowColor);
  ObjectSet("weekrange", OBJPROP_FIBOLEVELS, 2);
  ObjectSet("weekrange", OBJPROP_FIRSTLEVEL+0, 0.0);
  ObjectSetFiboDescription("weekrange", 0, "Previous Week Low");
  ObjectSet("weekrange", OBJPROP_FIRSTLEVEL+1, 1.0);
  ObjectSetFiboDescription("weekrange", 1, "Previous Week High");
  ObjectSet("weekrange", OBJPROP_RAY,true);
  ObjectSet("weekrange", OBJPROP_BACK,true);
  
  ObjectSet("weekrange", OBJPROP_COLOR, Black);
}

//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+
int start() {
  int shift = iBarShift(NULL,PERIOD_D1, Time[0]) + 1;	// yesterday
  HiPrice = iHigh(NULL, PERIOD_D1 ,shift);
  LoPrice = iLow (NULL, PERIOD_D1, shift);
  StartTime	= iTime(NULL, PERIOD_D1, 0);
  
  int weekshift = iBarShift(NULL, PERIOD_W1, Time[0]) + 1; // last week
  HiPriceWeek = iHigh(NULL, PERIOD_W1, weekshift);
  LoPriceWeek = iLow(NULL, PERIOD_W1, weekshift);
  StartTimeWeek = iTime(NULL, PERIOD_W1, 0);
  
  if(TimeDayOfWeek(iTime(NULL, PERIOD_D1, shift))==0/*Sunday*/) {
    //Add fridays high and low
    HiPrice = MathMax(HiPrice, iHigh(NULL,PERIOD_D1, shift+1));
    LoPrice = MathMin(LoPrice, iLow(NULL,PERIOD_D1, shift+1));
  }

  DrawFibo();
  return (0);
}
//+------------------------------------------------------------------+

